KDE 4.7 PyKDE API Reference

- KDE's Python API

# KLineEdit Class Reference

`from PyKDE4.kdeui import *`

Inherits: QLineEdit → QWidget → QObject,KCompletionBase

## Detailed Description

An enhanced QLineEdit widget for inputting text.

Detail

This widget inherits from QLineEdit and implements the following additional functionalities: a completion object that provides both automatic and manual text completion as well as multiple match iteration features, configurable key-bindings to activate these features and a popup-menu item that can be used to allow the user to set text completion modes on the fly based on their preference.

To support these new features KLineEdit also emits a few more additional signals. These are: completion( const QString& ), textRotation( KeyBindingType ), and returnPressed( const QString& ). The completion signal can be connected to a slot that will assist the user in filling out the remaining text. The text rotation signal is intended to be used to iterate through the list of all possible matches whenever there is more than one match for the entered text. The returnPressed( const QString& ) signals are the same as QLineEdit's except it provides the current text in the widget as its argument whenever appropriate.

This widget by default creates a completion object when you invoke the completionObject( bool ) member function for the first time or use setCompletionObject( KCompletion*, bool ) to assign your own completion object. Additionally, to make this widget more functional, KLineEdit will by default handle the text rotation and completion events internally when a completion object is created through either one of the methods mentioned above. If you do not need this functionality, simply use KCompletionBase.setHandleSignals( bool ) or set the boolean parameter in the above functions to false.

The default key-bindings for completion and rotation is determined from the global settings in KStandardShortcut. These values, however, can be overridden locally by invoking KCompletionBase.setKeyBinding(). The values can easily be reverted back to the default setting, by simply calling useGlobalSettings(). An alternate method would be to default individual key-bindings by using setKeyBinding() with the default second argument.

If EchoMode for this widget is set to something other than QLineEdit.Normal, the completion mode will always be defaulted to KGlobalSettings.CompletionNone. This is done purposefully to guard against protected entries such as passwords being cached in KCompletion's list. Hence, if the EchoMode is not QLineEdit.Normal, the completion mode is automatically disabled.

A read-only KLineEdit will have the same background color as a disabled KLineEdit, but its foreground color will be the one used for the read-write mode. This differs from QLineEdit's implementation and is done to give visual distinction between the three different modes: disabled, read-only, and read-write.

KLineEdit has also a password mode which depends of globals KDE settings. Use KLineEdit.setPasswordMode instead of QLineEdit.echoMode property to have a password field.

Usage

To enable the basic completion feature:

     KLineEdit *edit = new KLineEdit( this );
     KCompletion *comp = edit->completionObject();
     // Connect to the return pressed signal - optional
     connect(edit,SIGNAL(returnPressed(const QString&)),comp,SLOT(addItem(const QString&)));

To use a customized completion objects or your own completion object:

     KLineEdit *edit = new KLineEdit( this );
     KUrlCompletion *comp = new KUrlCompletion();
     edit->setCompletionObject( comp );
     // Connect to the return pressed signal - optional
     connect(edit,SIGNAL(returnPressed(const QString&)),comp,SLOT(addItem(const QString&)));

Note if you specify your own completion object you have to either delete it when you don't need it anymore, or you can tell KLineEdit to delete it for you:

     edit->setAutoDeleteCompletionObject( true );

Miscellaneous function calls :\n

     // Tell the widget to not handle completion and iteration automatically.
     edit->setHandleSignals( false );

     // Set your own key-bindings for a text completion mode.
     edit->setKeyBinding( KCompletionBase.TextCompletion, Qt.End );

     // Hide the context (popup) menu
     edit->setContextMenuPolicy( Qt.NoContextMenu );

     // Default the key-bindings back to the default system settings.
     edit->useGlobalKeyBindings();

"KDE Line Edit Widgets with clear-button and clickMessage"

Author:
  Dawit Alemayehu <adawit@kde.org>

## Signals
| aboutToShowContextMenu (QMenu menu)
| clearButtonClicked ()
| completion (QString a0)
| completionBoxActivated (QString a0)
| completionModeChanged (KGlobalSettings.Completion a0)
| returnPressed (QString a0)
| substringCompletion (QString a0)
| textRotation (KCompletionBase.KeyBindingType a0)
| userTextChanged (QString a0)
## Methods
| __init__ (self, QString string, QWidget parent=0)
| __init__ (self, QWidget parent=0)
bool | autoSuggest (self)
| clear (self)
QSize | clearButtonUsedSize (self)
QString | clickMessage (self)
KCompletionBox | completionBox (self, bool create=1)
| contextMenuEvent (self, QContextMenuEvent a0)
| copy (self)
| create (self, int a0=0, bool initializeWindow=1, bool destroyOldWindow=1)
QMenu | createStandardContextMenu (self)
| doCompletion (self, QString txt)
| dropEvent (self, QDropEvent a0)
bool | event (self, QEvent a0)
| focusInEvent (self, QFocusEvent ev)
| focusOutEvent (self, QFocusEvent ev)
bool | isClearButtonShown (self)
bool | isContextMenuEnabled (self)
bool | isSqueezedTextEnabled (self)
| keyPressEvent (self, QKeyEvent a0)
| makeCompletion (self, QString a0)
| mouseDoubleClickEvent (self, QMouseEvent a0)
| mousePressEvent (self, QMouseEvent a0)
| mouseReleaseEvent (self, QMouseEvent a0)
QString | originalText (self)
| paintEvent (self, QPaintEvent ev)
bool | passwordMode (self)
| resizeEvent (self, QResizeEvent a0)
| rotateText (self, KCompletionBase.KeyBindingType type)
| setClearButtonShown (self, bool show)
| setClickMessage (self, QString msg)
| setCompletedItems (self, QStringList items, bool autoSuggest=1)
| setCompletedText (self, QString a0)
| setCompletedText (self, QString a0, bool a1)
| setCompletionBox (self, KCompletionBox box)
| setCompletionMode (self, KGlobalSettings.Completion mode)
| setCompletionModeDisabled (self, KGlobalSettings.Completion mode, bool disable=1)
| setCompletionObject (self, KCompletion a0, bool hsig=1)
| setContextMenuEnabled (self, bool showMenu)
| setPasswordMode (self, bool b=1)
| setReadOnly (self, bool a0)
| setSqueezedText (self, QString text)
| setSqueezedTextEnabled (self, bool enable)
| setText (self, QString a0)
| setTrapReturnKey (self, bool trap)
| setUrl (self, KUrl url)
| setUrlDropsEnabled (self, bool enable)
| setUserSelection (self, bool userSelection)
bool | trapReturnKey (self)
bool | urlDropsEnabled (self)
| userCancelled (self, QString cancelText)
QString | userText (self)

## Signal Documentation

aboutToShowContextMenu | ( | QMenu | menu
| ) |  |  |

Emitted before the context menu is displayed.

The signal allows you to add your own entries into the the context menu that is created on demand.

NOTE: Do not store the pointer to the QMenu provided through since it is created and deleted on demand.

Parameters:

  | p | the context menu about to be displayed

Signal syntax:
  `QObject.connect(source, SIGNAL("aboutToShowContextMenu(QMenu*)"), target_slot)`

clearButtonClicked | ( |  | ) |

Emitted when the user clicked on the clear button

Signal syntax:
  `QObject.connect(source, SIGNAL("clearButtonClicked()"), target_slot)`

completion | ( | QString | a0
| ) |  |  |

Emitted when the completion key is pressed.

Please note that this signal is not emitted if the completion mode is set to CompletionNone or EchoMode is normal.

Signal syntax:
  `QObject.connect(source, SIGNAL("completion(const QString&)"), target_slot)`

completionBoxActivated | ( | QString | a0
| ) |  |  |

Emitted whenever the completion box is activated.

Signal syntax:
  `QObject.connect(source, SIGNAL("completionBoxActivated(const QString&)"), target_slot)`

completionModeChanged | ( | KGlobalSettings.Completion | a0
| ) |  |  |

Emitted when the user changed the completion mode by using the popupmenu.

Signal syntax:
  `QObject.connect(source, SIGNAL("completionModeChanged(KGlobalSettings::Completion)"), target_slot)`

returnPressed | ( | QString | a0
| ) |  |  |

Emitted when the user presses the return key.

The argument is the current text. Note that this signal is not emitted if the widget's EchoMode is set to QLineEdit.EchoMode.

Signal syntax:
  `QObject.connect(source, SIGNAL("returnPressed(const QString&)"), target_slot)`

substringCompletion | ( | QString | a0
| ) |  |  |

Emitted when the shortcut for substring completion is pressed.

Signal syntax:
  `QObject.connect(source, SIGNAL("substringCompletion(const QString&)"), target_slot)`

textRotation | ( | KCompletionBase.KeyBindingType | a0
| ) |  |  |

Emitted when the text rotation key-bindings are pressed.

The argument indicates which key-binding was pressed. In KLineEdit's case this can be either one of two values: PrevCompletionMatch or NextCompletionMatch. See KCompletionBase.setKeyBinding for details.

Note that this signal is not emitted if the completion mode is set to KGlobalSettings.CompletionNone or echoMode() is not normal.

Signal syntax:
  `QObject.connect(source, SIGNAL("textRotation(KCompletionBase::KeyBindingType)"), target_slot)`

userTextChanged | ( | QString | a0
| ) |  |  |

Emitted when the text is changed NOT by the suggested autocompletion: either when the user is physically typing keys, or when the text is changed programmatically, for example, by calling setText(). But not when automatic completion changes the text temporarily.

Since:
  4.2.2

Deprecated:
  since 4.5. You probably want to connect to textEdited() instead, which is emitted whenever the text is actually changed by the user (by typing or accepting autocompletion), without side effects from suggested autocompletion either. userTextChanged isn't needed anymore.

Signal syntax:
  `QObject.connect(source, SIGNAL("userTextChanged(const QString&)"), target_slot)`

## Method Documentation

__init__ | ( | self, |
|  | QString | string,
|  | QWidget | parent=0
| ) |  |  |

Constructs a KLineEdit object with a default text, a parent, and a name.

Parameters:

  | string | Text to be shown in the edit widget.
  | parent | The parent widget of the line edit.

__init__ | ( | self, |
|  | QWidget | parent=0
| ) |  |  |

Constructs a line edit

Parameters:

  | parent | The parent widget of the line edit.

bool autoSuggest | ( |  | self ) |

Whether in current state text should be auto-suggested

clear | ( |  | self ) |

Reimplemented to workaround a buggy QLineEdit.clear() (changing the clipboard to the text we just had in the lineedit)

QSize clearButtonUsedSize | ( |  | self ) |

Returns:
  the size used by the clear button

Since:
  KDE 4.1

QString clickMessage | ( |  | self ) |

Returns:
  the message set with setClickMessage

KCompletionBox completionBox | ( | self, |
|  | bool | create=1
| ) |  |  |

Returns:
  the completion-box, that is used in completion mode KGlobalSettings.CompletionPopup. This method will create a completion-box if none is there, yet.

Parameters:

  | create | Set this to false if you don't want the box to be created i.e. to test if it is available.

contextMenuEvent | ( | self, |
|  | QContextMenuEvent | a0
| ) |  |  |

Re-implemented for internal reasons. API not affected.

See QLineEdit.contextMenuEvent().

copy | ( |  | self ) |

Reimplemented for internal reasons, the API is not affected.

create | ( | self, |
|  | int | a0=0,
|  | bool | initializeWindow=1,
|  | bool | destroyOldWindow=1
| ) |  |  |

Reimplemented for internal reasons, the API is not affected.

QMenu createStandardContextMenu | ( |  | self ) |

Re-implemented for internal reasons. API not affected.

See QLineEdit.createStandardContextMenu().

doCompletion | ( | self, |
|  | QString | txt
| ) |  |  |

Do completion now. This is called automatically when typing a key for instance. Emits completion() and/or calls makeCompletion(), depending on emitSignals and handleSignals.

Since:
  4.2.1

dropEvent | ( | self, |
|  | QDropEvent | a0
| ) |  |  |

Re-implemented to handle URI drops.

See QLineEdit.dropEvent().

bool event | ( | self, |
|  | QEvent | a0
| ) |  |  |

Re-implemented for internal reasons. API not affected.

focusInEvent | ( | self, |
|  | QFocusEvent | ev
| ) |  |  |

focusOutEvent | ( | self, |
|  | QFocusEvent | ev
| ) |  |  |

bool isClearButtonShown | ( |  | self ) |

Returns:
  whether or not the clear button is shown

bool isContextMenuEnabled | ( |  | self ) |

Returns true when the context menu is enabled.

Deprecated:
  use contextMenuPolicy

bool isSqueezedTextEnabled | ( |  | self ) |

Returns true if text squeezing is enabled. This is only valid when the widget is in read-only mode.

keyPressEvent | ( | self, |
|  | QKeyEvent | a0
| ) |  |  |

Re-implemented for internal reasons. API not affected.

See QLineEdit.keyPressEvent().

makeCompletion | ( | self, |
|  | QString | a0
| ) |  |  |

Completes the remaining text with a matching one from a given list.

mouseDoubleClickEvent | ( | self, |
|  | QMouseEvent | a0
| ) |  |  |

Re-implemented for internal reasons. API not affected.

See QWidget.mouseDoubleClickEvent().

mousePressEvent | ( | self, |
|  | QMouseEvent | a0
| ) |  |  |

Re-implemented for internal reasons. API not affected.

See QLineEdit.mousePressEvent().

mouseReleaseEvent | ( | self, |
|  | QMouseEvent | a0
| ) |  |  |

Re-implemented for internal reasons. API not affected.

See QLineEdit.mouseReleaseEvent().

QString originalText | ( |  | self ) |

Returns the original text if text squeezing is enabled. If the widget is not in "read-only" mode, this function returns the same thing as QLineEdit.text().

See also:
  QLineEdit

paintEvent | ( | self, |
|  | QPaintEvent | ev
| ) |  |  |

bool passwordMode | ( |  | self ) |

Returns:
  returns true if the lineedit is set to password mode echoing

resizeEvent | ( | self, |
|  | QResizeEvent | a0
| ) |  |  |

Re-implemented for internal reasons. API not affected.

See QLineEdit.resizeEvent().

rotateText | ( | self, |
|  | KCompletionBase.KeyBindingType | type
| ) |  |  |

Iterates through all possible matches of the completed text or the history list.

This function simply iterates over all possible matches in case multiple matches are found as a result of a text completion request. It will have no effect if only a single match is found.

Parameters:

  | type | The key-binding invoked.

setClearButtonShown | ( | self, |
|  | bool | show
| ) |  |  |

This makes the line edit display an icon on one side of the line edit which, when clicked, clears the contents of the line edit. This is useful for such things as location or search bars.

setClickMessage | ( | self, |
|  | QString | msg
| ) |  |  |

This makes the line edit display a grayed-out hinting text as long as the user didn't enter any text. It is often used as indication about the purpose of the line edit.

setCompletedItems | ( | self, |
|  | QStringList | items,
|  | bool | autoSuggest=1
| ) |  |  |

Same as the above function except it allows you to temporarily turn off text completion in CompletionPopupAuto mode.

Parameters:

  | items | list of completion matches to be shown in the completion box.
  | autoSuggest | true if you want automatic text completion (suggestion) enabled.

setCompletedText | ( | self, |
|  | QString | a0
| ) |  |  |

This function simply sets the lineedit text and highlights the text appropriately if the boolean value is set to true.

Parameters:

  | text |
  | marked |

setCompletedText | ( | self, |
|  | QString | a0,
|  | bool | a1
| ) |  |  |

This function simply sets the lineedit text and highlights the text appropriately if the boolean value is set to true.

Parameters:

  | text |
  | marked |

setCompletionBox | ( | self, |
|  | KCompletionBox | box
| ) |  |  |

Set the completion-box to be used in completion mode KGlobalSettings.CompletionPopup. This will do nothing if a completion-box already exists.

Parameters:

  | box | The KCompletionBox to set

setCompletionMode | ( | self, |
|  | KGlobalSettings.Completion | mode
| ) |  |  |

Re-implemented from KCompletionBase for internal reasons.

This function is re-implemented in order to make sure that the EchoMode is acceptable before we set the completion mode.

See KCompletionBase.setCompletionMode

setCompletionModeDisabled | ( | self, |
|  | KGlobalSettings.Completion | mode,
|  | bool | disable=1
| ) |  |  |

Disables completion modes by makeing them non-checkable.

The context menu allows to change the completion mode. This method allows to disable some modes.

setCompletionObject | ( | self, |
|  | KCompletion | a0,
|  | bool | hsig=1
| ) |  |  |

Reimplemented for internal reasons, the API is not affected.

setContextMenuEnabled | ( | self, |
|  | bool | showMenu
| ) |  |  |

Enables/disables the popup (context) menu.

This method only works if this widget is editable, i.e. read-write and allows you to enable/disable the context menu. It does nothing if invoked for a none-editable combo-box.

By default, the context menu is created if this widget is editable. Call this function with the argument set to false to disable the popup menu.

Parameters:

  | showMenu | If true, show the context menu.

Deprecated:
  use setContextMenuPolicy

setPasswordMode | ( | self, |
|  | bool | b=1
| ) |  |  |

set the line edit in password mode. this change the EchoMode according to KDE preferences.

Parameters:

  | b | true to set in password mode

setReadOnly | ( | self, |
|  | bool | a0
| ) |  |  |

Sets the lineedit to read-only. Similar to QLineEdit.setReadOnly but also takes care of the background color, and the clear button.

setSqueezedText | ( | self, |
|  | QString | text
| ) |  |  |

Properly sets the squeezed text whenever the widget is created or resized.

setSqueezedTextEnabled | ( | self, |
|  | bool | enable
| ) |  |  |

Enable text squeezing whenever the supplied text is too long. Only works for "read-only" mode.

Note that once text squeezing is enabled, QLineEdit.text() and QLineEdit.displayText() return the squeezed text. If you want the original text, use originalText.

See also:
  QLineEdit

setText | ( | self, |
|  | QString | a0
| ) |  |  |

Re-implemented to enable text squeezing. API is not affected.

setTrapReturnKey | ( | self, |
|  | bool | trap
| ) |  |  |

By default, KLineEdit recognizes Key_Return and Key_Enter and emits the returnPressed() signals, but it also lets the event pass, for example causing a dialog's default-button to be called.

Call this method with trap = true to make KLineEdit stop these events. The signals will still be emitted of course.

See also:
  trapReturnKey()

setUrl | ( | self, |
|  | KUrl | url
| ) |  |  |

Sets url into the lineedit. It uses KUrl.prettyUrl() so that the url is properly decoded for displaying.

setUrlDropsEnabled | ( | self, |
|  | bool | enable
| ) |  |  |

Enables/Disables handling of URL drops. If enabled and the user drops an URL, the decoded URL will be inserted. Otherwise the default behavior of QLineEdit is used, which inserts the encoded URL.

Parameters:

  | enable | If true, insert decoded URLs

setUserSelection | ( | self, |
|  | bool | userSelection
| ) |  |  |

Sets the widget in userSelection mode or in automatic completion selection mode. This changes the colors of selections.

bool trapReturnKey | ( |  | self ) |

Returns:
  true if keyevents of Key_Return or

Key_Enter will be stopped or if they will be propagated.

See also:
  setTrapReturnKey ()

bool urlDropsEnabled | ( |  | self ) |

Returns true when decoded URL drops are enabled

userCancelled | ( | self, |
|  | QString | cancelText
| ) |  |  |

Resets the current displayed text. Call this function to revert a text completion if the user cancels the request. Mostly applies to popup completions.

QString userText | ( |  | self ) |

Returns the text as given by the user (i.e. not autocompleted) if the widget has autocompletion disabled, this function returns the same as QLineEdit.text().

Since:
  4.2.2